#!/usr/bin/env python3
from pathlib import Path
from sys import argv

from hpvm_profiler import profile_configs, read_hpvm_configs

# relative to cwd()
benchmarks_bindir = Path("../hpvm-c")
# relative to location of this file
benchmarks_srcdir = Path(__file__).parent / "../hpvm-c/benchmarks"
# We're called in the "current" binary directory.
# For example (depending on where build dir is),
# "hpvm/build/tools/hpvm/test/dnn_benchmarks/profiling".
# So we know where the benchmark binaries are due to source directory structure,
# and this is not hardcoding.
dnn = argv[1]
bench_bin_file = benchmarks_bindir / dnn
config_file = benchmarks_srcdir / dnn / "data/tuner_confs.txt"
out_config_file = f"./{dnn}.txt"
profile_configs(bench_bin_file, config_file, out_config_file)
